use iced::widget::markdown;
use iced::Element;
use iced::Theme;

#[derive(Debug, Clone, Default)]
pub struct Markdown {
    markdown: Vec<markdown::Item>,
}

#[derive(Debug)]
pub enum Message {
    LinkClicked(markdown::Url),
}

impl Markdown {
    pub fn new() -> Self {
        Self {
            markdown: markdown::parse("This is some **Markdown**!").collect(),
        }
    }

    pub fn view(&self) -> Element<'_, Message> {
        markdown::view(
            &self.markdown,
            markdown::Settings::default(),
            markdown::Style::from_palette(Theme::TokyoNightStorm.palette()),
        )
        .map(Message::LinkClicked)
        .into()
    }

    pub fn update(_state: &mut Self, message: Message) {
        match message {
            Message::LinkClicked(url) => {
                println!("The following url was clicked: {url}");
            }
        }
    }
}
